#ifndef SHADOW_H
#define SHADOW_H

struct shadow {
  bool enabled;

  uint32_t angle;
  uint32_t distance;

  struct rgba_color color;
};

void shadow_init(struct shadow* shadow);
bool shadow_set_enabled(struct shadow* shadow, bool enabled);
bool shadow_set_angle(struct shadow* shadow, float angle);
bool shadow_set_distance(struct shadow* shadow, float distance);
bool shadow_set_color(struct shadow* shadow, uint32_t color);
CGRect shadow_get_bounds(struct shadow* shadow, CGRect reference_bounds);

static bool shadow_parse_sub_domain(struct shadow* shadow, FILE* rsp, struct token property, char* message);

#endif

